#ifndef __SLIDEFACE_H__
#define __SLIDEFACE_H__

#include "slideprimitive.h"

class CSLIDEWorld;
class CSLIDEPoint;

//////////////////////////////////////////////////////////////////////
// CSLIDEFace Class
//

class CSLIDEFaceIter;

class CSLIDEFace : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Friends
//
public:
  friend class CSLIDEFaceIter;

//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEFace();
  virtual ~CSLIDEFace();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, CHAR *pcID, 
		    CListInt *plistPointIDs);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Iteration Functions
//
public:
  virtual CSLIDEPrimitiveIter *AllocateIter();
  virtual VOID FreeIter(CSLIDEPrimitiveIter *pCSLIDEFaceIter);

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:

////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 2
// 

//////////////////////////////////////////////////
// Rendering
//
public:
  virtual VOID Render();

protected:

//////////////////////////////////////////////////
// Input Functions
//
public:
  virtual CSLIDEPoint *SelectPoint(FLOAT fX, FLOAT fY);

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);
  virtual VOID WriteSLIDEMorph(FILE *fpOutputFile);

// 
// END  : ASSIGNMENT 2
/////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual UINT_32 GetPointCount();

  static inline BOOL GetRenderStartPositionEnabled();
  static inline VOID SetRenderStartPositionEnabled(BOOL bRenderStartPositionEnabled);

//////////////////////////////////////////////////
// Class Variables
//
protected:
  static BOOL m_bRenderStartPositionEnabled;

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListInt *m_plistPointIDs;
  CListInt m_listCSLIDEPoint;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline BOOL CSLIDEFace::GetRenderStartPositionEnabled()
{
  return m_bRenderStartPositionEnabled;
}

inline VOID CSLIDEFace::SetRenderStartPositionEnabled(BOOL bRenderStartPositionEnabled)
{
  m_bRenderStartPositionEnabled = bRenderStartPositionEnabled;
}

//////////////////////////////////////////////////////////////////////
// CSLIDEFaceIter Class
//

class CSLIDEFaceIter : public CSLIDEPrimitiveIter
{
//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEFaceIter();
  virtual ~CSLIDEFaceIter();
  virtual VOID Init(CSLIDEFace *pCSLIDEFace);
  virtual VOID Uninit();

//////////////////////////////////////////////////
// Iteration Functions
//
public:
  virtual CSLIDEPoint *PeekFirstCSLIDEPoint();
  virtual CSLIDEPoint *PeekNextCSLIDEPoint();
  virtual CSLIDEPoint *PeekLastCSLIDEPoint();
  virtual CSLIDEPoint *PeekPrevCSLIDEPoint();

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListIterInt m_iter;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//


#endif // __SLIDEFACE_H__
