source globals.tcl

proc CreateWindow { parent name } {
    if { $name == {} } {
	return false
    }

    if { $parent == {} } {
	set root .$name
    } elseif { $parent == "." } {
	set root .$name
    } else {
	set root $parent.$name
    }

    set varWindow $name

#    toplevel $root

    CreateMenuBar $root menubar \
	    [list \
	      [list file File left \
	        [list \
	          [list command "w: Write" "$varWindow handleWrite"] \
	          [list command "m: Write Morph" "$varWindow handleWriteMorph"] \
	          [list command "esc: Exit" exit] \
                ] \
	      ] \
	      [list options Options left \
	        [list \
	          [list checkbutton "s: Draw Start Position" $varWindow drawStartPosition setDrawStartPosition] \
	          [list checkbutton "e: Display Events" $varWindow displayEvents setDisplayEvents] \
		] \
	      ] \
	      [list help Help right \
	        [list \
	          [list command "L Button - Selects and drags vertices of the polygons" ""] \
                ] \
	      ] \
	    ]

    CreateToolBar $root readout1 \
	    [list \
	      [list text "Frames Per Second:  "] \
	      [list text "Requested = "] \
	      [list textOut $varWindow framesPerSecondRequested] \
	    ]
    CreateToolBar $root readout2 \
	    [list \
	      [list text "Update Time = "] \
	      [list textOut $varWindow updateTime] \
	      [list text "Render Time = "] \
	      [list textOut $varWindow renderTime] \
	    ]

    pack $root.menubar $root.readout1 $root.readout2 -side top -fill x

    ##################################################
    # Togl Widget
    #
    togl $root.toglarea -width 400 -height 400 -rgba true -double true -depth true -stencil true -ident %name

    bind $root.toglarea <KeyPress> "$varWindow handleKeyboard %K 0 %x %y"
    #bind $root.toglarea <KeyRelease> "$varWindow handleKeyboard %K 1 %x %y"
    bind $root.toglarea <ButtonPress> "$varWindow handleMouseButton %b 0 %x %y"
    bind $root.toglarea <ButtonRelease> "$varWindow handleMouseButton %b 1 %x %y"
    bind $root.toglarea <B1-Motion> "$varWindow handleMouseMotion 1 %x %y"
    bind $root.toglarea <B2-Motion> "$varWindow handleMouseMotion 2 %x %y"
    bind $root.toglarea <B3-Motion> "$varWindow handleMouseMotion 3 %x %y"

    wm minsize $root 1 1
    wm maxsize $root 640 480
    #wm maxsize $root 1000 1000
    wm resizable $root 1 1

    focus $root.toglarea

    pack $root.toglarea -side left -fill both -expand 1
    #pack $root -fill both -expand 1

    return true
}

proc DestroyWindow { parent name } {
    if { $name == {} } {
	return false
    }

    if { $parent == {} } {
	set root .$name
    } elseif { $parent == "." } {
	set root .$name
    } else {
	set root $parent.$name
    }

    set varWindow $name

    destroy $root
}


